import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import objectdraw.*;

// ENTER YOUR NAME AND LAB SECTION HERE 

public class SpamFilter extends Controller implements ActionListener, ItemListener { 

  // components for the server info
  private JTextField serverField; 
  private JTextField userField; 
  private JPasswordField passwordField;

  // the filter text area
  private JTextArea filters; 

  // components for the buttoms and good/spam choice
  private JButton getMailButton, refilterButton; 
  private JComboBox viewMail; 

  // where all the results are put
  private JTextArea resultArea; 

  // this MessageList keeps a list of all messages
  // from downloaded from the server
  private MessageList allMessages; 

  public void begin() { 
    resize(800,600);

    JPanel top = new JPanel(); 
    JPanel left = new JPanel(); 
    JPanel right = new JPanel(); 

    left.setLayout(new GridLayout(5, 1)); 
    left.add(new JLabel("Mail Account Info", JLabel.CENTER)); 

    // Create the server field
    JPanel tempPanel = new JPanel(); 
    tempPanel.add(new JLabel("Server:")); 
    serverField = new JTextField("fuji.cs.williams.edu", 20); 
    tempPanel.add(serverField); 
    left.add(tempPanel); 

    // Create the user field
    tempPanel = new JPanel(); 
    tempPanel.add(new JLabel("User:")); 
    userField = new JTextField("", 10); 
    tempPanel.add(userField); 
    left.add(tempPanel); 

    // Create the password field
    tempPanel = new JPanel(); 
    tempPanel.add(new JLabel("Pass:")); 
    passwordField = new JPasswordField("", 10); 
    tempPanel.add(passwordField); 
    left.add(tempPanel); 

    getMailButton = new JButton("Get Mail"); 
    JPanel button = new JPanel();
    button.add(getMailButton);
    left.add(button); 

    right.setLayout(new BorderLayout()); 
    right.add(new JLabel("Filter Terms"), BorderLayout.NORTH); 
    filters = new JTextArea(); 
    right.add(filters, BorderLayout.CENTER); 
    refilterButton = new JButton("Refilter Email");
    button = new JPanel();
    button.add(refilterButton);
    right.add(button, BorderLayout.SOUTH); 

    top.setLayout(new GridLayout(1, 2)); 
    top.add(left); 
    top.add(right); 

    Container content = getContentPane(); 
    content.add(top, BorderLayout.NORTH); 
    JPanel tmp = new JPanel(); 
    viewMail = new JComboBox(); 
    viewMail.addItem("View Good"); 
    viewMail.addItem("View Spam"); 

    tmp.add(viewMail); 
    content.add(tmp, BorderLayout.SOUTH); 

    getMailButton.addActionListener(this); 
    refilterButton.addActionListener(this); 
    viewMail.addItemListener(this); 

    JScrollPane pane = new JScrollPane(); 
    resultArea = new JTextArea(); 
    pane.setViewportView(resultArea); 
    content.add(pane, BorderLayout.CENTER); 

    validate(); 

  } 

  /*
   * This method performs the filtering, based
   * one whether we want the Good or Spam messages
   * and what terms are in the filter list.
   */
  private void filterMessageList() { 
    if (allMessages != null) { 
      MessageList ml;
      // split will break the string into an array, 
      // with one string for each line.
      String[] filterTerms = filters.getText().split("\n"); 

      if (viewMail.getSelectedItem().equals("View Good")) {
        ml = allMessages.getGood(filterTerms); 
      } else {
        ml = allMessages.getSpam(filterTerms); 
      }

      // show the result in the main text area
      resultArea.setText(ml.toString()); 
    } 
  } 

  @SuppressWarnings("deprecation")  // This line is needed because of the library we are using...
  public void actionPerformed(ActionEvent e) { 
    if (e.getSource() == getMailButton) { 
      // establish a connection to the server
      String server = serverField.getText();
      String user = userField.getText();
      String password = passwordField.getText();   

      MailConnection connection = new MailConnection(server, user, password);  
      if (connection.isConnected()) { 

        /* Code for the first step.  Comment out when you start MessageList */
        if (connection.getNumMsgs() > 0) {
          Message m = new Message(connection.header(1)); 
          resultArea.setText("-Message.getFrom() returned:\n" + m.getFrom());
          resultArea.append("\n-Message.getSubject() returned:\n" + m.getSubject());
          resultArea.append("\n-Message.toString() returned:\n" + m.toString());
        } else {
          resultArea.setText("No Messages in mailbox");
        }
        /* End of Code to comment out when you start MessageList */

        // INSERT CODE HERE 

        // disconnect from the server
        connection.disconnect(); 
      } 
    } else {
      // pressed the refilter button
      filterMessageList(); 
    } 
  } 

  /*
   * When the combobox changes, perform the refilter the mail.
   */
  public void itemStateChanged(ItemEvent e) { 
    filterMessageList(); 
  } 
} 
